@part(startup, root="studioman.mss")
@chapter(Computer Systems)
@label(startup-chap)
@section(System Startup and Shutdown)

@subsection(IBM System Startup)
@begin(enumerate)
Is the IBM power on?  If so, you can proceed to login (see Section @ref(login)
below.)

Remove any diskettes from the IBM disk drive.

Turn on the IBM power using the red switch on the right side of the computer.

After a minute, you will get a prompt (the character ">").

If this is your first time to use the Studio computer, procede with the
next section.  Otherwise, skip to Section @ref(login).
@end(enumerate)

@subsection(Making a directory)
The first time you use the computer in the studio, you @i(must) create
a place to keep your work.  This should only be done the first time you
use the Studio computer.
Type the following line, substituting @i(your own initials) for @i(xyz):
@begin(display)
mkdir \xyz
@end(display)
You have now created a @i(directory) to hold your personal data.  Everyone
who works in the Studio has a private directory named with their initials.

@subsection(Logging in)
@label(login)
Since each person has his or her own private directory on the computer,
you @i(must) tell the computer what directory to use before you do
any work.  Failure to do this will at best cause you to lose data and
at worst could cause you to destroy someone else's work by accident.

Type the following, where @i(your initials) are substituted for @i(xyz):
@begin(display)
cd \xyz
@end(display)
That's all there is to it!  Now any data file you create will be kept
in your own private directory and when you ask for a file, you will
get your own, not one that belongs to someone else but has the same
name.

@subsection(IBM System Shutdown)
When you are done, you can safely turn off the IBM computer using the
red power switch.
@section(The Editor)
@include(epsilon.mss)

@section(Utilities)
Utilities are commonly used programs that mostly have to do with file
manipulation.  To run a utility, just type a @i(command line) to the
computer.  Normally, you name the utility and then type some more
information.    You may find the following useful:
@begin(description)
dir@\Lists the names of all of your files.
@index(listing, file) @index(catalog, file) @index(directory, file)

del @i(filename)@\Removes a file.  Be careful: once it's gone, you can't get
it back.
@index(deleting files) @index(removing files) 

type @i(filename)@\Prints a file on the screen.  Type @c(ctrl)S to stop
the printing, and @c(ctrl)Q to continue.
@index(displaying files)

copy @i(filename1)  @i(filename2)@\Copies @i(filename1) to @i(filename2).
@Index(copying files)

print @i(filename)@\Prints @i(filename) in the studio. @Index(printing
files) The first time you use this command, you will be prompted for the
name of the printer at which time you should just type @c(return).  See
Chapter @ref(print-chap) for details.  (To use
a Computation Center printer, see the next section on file transfers.)

@end(description)
@index(file utility programs)

