@make(text)
@style(spacing 1)
@style(fontfamily "Helvetica10")
@majorheading(@p(The CMU MIDI Toolkit))
@center(Roger B. Dannenberg)
@center(@i(@value(date)))

The @i(CMU MIDI Toolkit) (CMT) is a software package designed for experimental
computer music education, composition, performance, and research.   CMT
includes a compiler for a simple, text-based music language, and software
for recording, playing, and computing MIDI data in real time.
CMT has three major attractions:
the flexibility of an open-ended design,
the availability of source code, and 
low system cost.

What does CMT do?  The major components and their functions are:
@begin(itemize)
@b(Adagio) is a language and an associated compiler.  In Adagio, a note
is represented by a line of text that specifies attributes such as pitch,
duration, and loudness.  Adagio is quite flexible and is 
compatible with several different ways of thinking about scores.  For
example, ``Q'' stands for a quarter note, but duration can also be
indicated by ``U87'', which means 0.87 seconds. 
Adagio also supports arbitrary tuning systems.

@b(Transcribe) reads input from a MIDI keyboard or other MIDI controller
and produces an Adagio score.  The score can be played back using Adagio,
or it can be edited with a text editor to make alterations.  Since
Transcribe output is at least somewhat readable by people, it
can also be used for performance analysis.

@b(Record) is a combination of Adagio and Transcribe.  It plays an
existing Adagio score while transcribing a performance.
Thus, complex compositions can be created one part at a time as if
using a multi-track tape recorder.

@b(DxGet) and @b(DxPut) are programs for recording and replaying MIDI
system exclusive messages.  These programs are typically used to save
and restore synthesis parameters for a digital synthesizer.

@b(Moxc) is a real-time programming environment that is ideal for writing
interactive music programs.  Moxc is an extension of the C programming
language and is based on Douglas Collinge's @i(Moxie) language.

Also provided are routines (in C) that allow direct production of MIDI output.
Other routines are available to read MIDI data from a circular input 
buffer and to get the current time with 0.01 second resolution.
@end(itemize)

@b(Required hardware and software.)  CMT runs on an IBM-XT or IBM-AT
with a Roland MPU-401 MIDI interface and IBM-PC interface adapter.
You should also have a screen-based text editor.
To use Moxc, you will need a Lattice C compiler.

@b(Other details.)  CMT will be distributed by the CMU Center for Art and
Technology, Carnegie-Mellon University, Pittsburgh, PA, 15213.
For $20 to cover our costs, we will send you two disks including source
code and an 80 page manual.
We hope that users will contribute new software to the system
and enhance the existing software in various ways.  We will 
encourage this by helping to integrate and document new software
and by distributing software updates to CMT users.  

