; Canon -- a score language
; copyright 1988, Roger B. Dannenberg
; 10 Jan 88


(setq c0 0) (setq cs0 1) (setq df0 1) (setq d0 2) (setq ds0 3)
 (setq ef0 3) (setq e0 4) (setq f0 5) (setq fs0 6) (setq gf0 6)
 (setq g0 7) (setq gs0 8) (setq af0 8) (setq a0 9) (setq as0 10)
 (setq bf0 10) (setq b0 11) 

(setq c1 12) (setq cs0 13) (setq df0 13) (setq d0 14) (setq ds0 15)
 (setq ef0 15) (setq e0 16) (setq f0 17) (setq fs0 18) (setq gf0 18)
 (setq g0 19) (setq gs0 20) (setq af0 20) (setq a0 21) (setq as0 22)
 (setq bf0 22) (setq b0 23) 

(setq c2 24) (setq cs0 25) (setq df0 25) (setq d0 26) (setq ds0 27)
 (setq ef0 27) (setq e0 28) (setq f0 29) (setq fs0 30) (setq gf0 30)
 (setq g0 31) (setq gs0 32) (setq af0 32) (setq a0 33) (setq as0 34)
 (setq bf0 34) (setq b0 35) 

(setq c3 36) (setq cs0 37) (setq df0 37) (setq d0 38) (setq ds0 39)
 (setq ef0 39) (setq e0 40) (setq f0 41) (setq fs0 42) (setq gf0 42)
 (setq g0 43) (setq gs0 44) (setq af0 44) (setq a0 45) (setq as0 46)
 (setq bf0 46) (setq b0 47) 

(setq c4 48) (setq cs0 49) (setq df0 49) (setq d0 50) (setq ds0 51)
 (setq ef0 51) (setq e0 52) (setq f0 53) (setq fs0 54) (setq gf0 54)
 (setq g0 55) (setq gs0 56) (setq af0 56) (setq a0 57) (setq as0 58)
 (setq bf0 58) (setq b0 59) 

(setq c5 60) (setq cs0 61) (setq df0 61) (setq d0 62) (setq ds0 63)
 (setq ef0 63) (setq e0 64) (setq f0 65) (setq fs0 66) (setq gf0 66)
 (setq g0 67) (setq gs0 68) (setq af0 68) (setq a0 69) (setq as0 70)
 (setq bf0 70) (setq b0 71) 

(setq c6 72) (setq cs0 73) (setq df0 73) (setq d0 74) (setq ds0 75)
 (setq ef0 75) (setq e0 76) (setq f0 77) (setq fs0 78) (setq gf0 78)
 (setq g0 79) (setq gs0 80) (setq af0 80) (setq a0 81) (setq as0 82)
 (setq bf0 82) (setq b0 83) 

(setq c7 84) (setq cs0 85) (setq df0 85) (setq d0 86) (setq ds0 87)
 (setq ef0 87) (setq e0 88) (setq f0 89) (setq fs0 90) (setq gf0 90)
 (setq g0 91) (setq gs0 92) (setq af0 92) (setq a0 93) (setq as0 94)
 (setq bf0 94) (setq b0 95) 

(setq c8 96) (setq cs0 97) (setq df0 97) (setq d0 98) (setq ds0 99)
 (setq ef0 99) (setq e0 100) (setq f0 101) (setq fs0 102) (setq gf0 102)
 (setq g0 103) (setq gs0 104) (setq af0 104) (setq a0 105) (setq as0 106)
 (setq bf0 106) (setq b0 107) 

(defmacro at (x s)
 `(let ((starttime *time*))
    (prog2
      (setq *time* (+ *time* (* *dur* ,x)))
      ,s
      (setq *time* starttime))))


(defmacro at-abs (x s)
 `(let ((starttime *time*))
    (prog2
      (setq *time* ,x)
      ,s
      (setq *time* starttime))))


(defmacro extract (start stop score)
 `(let ((oldstart *start*) (oldstop *stop*) endtime)
    (setq *start* (+ *time* (* *dur* ,start)))
    (setq *stop* (+ *time* (* *dur* ,stop)))
    (setq endtime ,score)
    (setq *start* oldstart)
    (setq *stop* oldstop)
    endtime))


(defmacro extract-abs (start stop score)
 `(let ((oldstart *start*) (oldstop *stop*) endtime)
    (setq *start* ,start)
    (setq *stop* ,stop)
    (setq endtime ,score)
    (setq *start* oldstart)
    (setq *stop* oldstop)
    endtime))


(defmacro loud (x s)
 `(let ((loudness *loud*))
    (prog2 
      (setq *loud* (+ *loud* ,x))
      ,s
      (setq *loud* loudness))))


(defmacro loud-abs (x s)
 `(let ((loudness *loud*))
    (prog2
      (setq *loud* ,x)
      ,s
      (setq *loud* loudness))))


(defmacro make (score)
  `(let () (make-init) ,score (make-finish)))

(defun make-finish ()
  (close adagio-file)
  'OK)

; in Canon, we simulate having a ``sticky'' program for each voice
; adagio-programs is the per-voice state, adagio-program keeps track of
; the adagio state

(setq adagio-programs (make-array 16))

(defun make-init ()
  (setq adagio-time 0)
  (setq adagio-dur -999)
  (setq adagio-pitch 48)
  (setq adagio-loud 100)
  (setq adagio-voice 1)
  (setq adagio-program 1)
  (dotimes (i 16) (setf (aref adagio-programs i) 1))
  (setq adagio-file (openo "current-adagio-file.gio"))
  (setq *time* 0.0)
  (setq *dur* 1.0)
  (setq *duty* 1.0)
  (setq *start* 0)
  (setq *stop* 1000000)
  (setq *loud* 0)
  (setq *transpose* 0))

;## mp -- make followed by play
;
(defmacro mp (s) `(progn (make ,s) (play)))

(defun note (pitch &optional dur duty vel chan)
  (let* ((start (truncate *time*))
         stop
	 ontime
	 cutoff
	 (velocity 100)
	 (channel 1))
    
    (cond ((null dur) (setq dur 100)))
    (setq dur (truncate (* *dur* dur)))
    (setq stop (+ start dur))

    (setq ontime dur)
    (cond (duty (setq ontime (* ontime 0.01 duty))))
    (setq ontime (truncate (* *duty* ontime)))
    (setq cutoff (+ start ontime))

    (setq start (max *start* start))
    (setq stop (min *stop* stop))
    (setq cutoff (min *stop* cutoff))

    (cond ((< start cutoff)
	   (format adagio-file "T~A" start)
	   (setq pitch (+ *transpose* pitch))
	   (cond ((/= pitch adagio-pitch)
		  (setq adagio-pitch pitch)
		  (format adagio-file " P~A" adagio-pitch)))
	   (setq ontime (- cutoff start))
	   (cond ((/= ontime adagio-dur)
	          (setq adagio-dur ontime)
		  (format adagio-file " U~A" adagio-dur)))
	   (cond (vel (setq velocity (truncate vel))))
	   (setq velocity (+ velocity *loud*))
	   (cond ((/= velocity adagio-loud)
	          (setq adagio-loud velocity)
		  (format adagio-file " L~A" velocity)))
	   (cond ((and chan (/= adagio-voice (truncate chan)))
		  (setq adagio-voice (truncate chan))
		  (format adagio-file " V~A" adagio-voice)))
	   (cond ((/= adagio-program (aref adagio-programs (1- channel)))
		  (setq adagio-program (aref adagio-programs (1- channel)))
	   	  (format adagio-file " Z~A" adagio-program)))
	   (format adagio-file "~%")))
     stop))

(defun play ()
  (dos "cat current-adagio-file.gio"))

(defun prgm (p &opt chan)
  (cond ((null chan) (setq chan 1)))
  (cond ((/= p (aref adagio-programs (1- chan)))
	 (setf (aref adagio-programs (1- chan)) p)
	 (setq adagio-program p)
	 (format adagio-file "T~A R Z~A" (fix *time*) (fix p)))))


(defun rest (&optional dur duty)
  (let* ((start (truncate *time*))
         stop)

    (cond ((null dur) (setq dur 100)))
    (setq dur (truncate (* *dur* dur)))
    (setq stop (min *stop* (+ start dur)))
    stop))

(defmacro seq (&rest scores)
  (let (body)
    (setq body (mapcar (lambda (s) (list 'setq '*time* s)) scores))
    (cons 'let
     (cons '((starttime *time*) (endtime *time*))
      (nconc body '((setq endtime *time*)
	   	    (setq *time* starttime)
		    endtime))))))

(defmacro seqrep (pair score)
 `(let ((starttime *time*) (endtime *time*))
    (dotimes ,pair (setq *time* ,score))
    (setq endtime *time*)
    (setq *time* starttime)
    endtime))


(setq sim max)  ;wow, this is too easy!


(defmacro simrep (pair score)
 `(let ((endtime *time*))
    (dotimes ,pair (setq endtime (max endtime ,score)))
    endtime))


(defmacro stretch (x s)
 `(let ((dur *dur*))
    (prog2 
      (setq *dur* (* *dur* ,x))
      ,s
      (setq *dur* dur))))


(defmacro stretch-abs (x s)
 `(let ((dur *dur*))
    (prog2
      (setq *dur* ,x)
      ,s
      (setq *dur* dur))))


(defmacro sustain (x s)
 `(let ((duty *duty*))
    (prog2 
      (setq *duty* (* *duty* ,x))
      ,s
      (setq *duty* duty))))


(defmacro sustain-abs (x s)
 `(let ((duty *duty*))
    (prog2
      (setq *duty* ,x)
      ,s
      (setq *duty* duty))))


(defmacro trans (x s)
 `(let ((transpose *transpose*))
    (prog2 
      (setq *transpose* (+ *transpose* ,x))
      ,s
      (setq *transpose* transpose))))


(defmacro trans-abs (x s)
 `(let ((transpose *transpose*))
    (prog2
      (setq *transpose* ,x)
      ,s
      (setq *transpose* transpose))))
