@part(mm, root="cmtman.mss")
@chapter(MM: MIDI Monitor)
The MM@Index(MM) program is a very simple MIDI monitor@Index(monitor, MIDI
monitor), a program that prints a readable form of any MIDI input it
receives.  MM is useful for finding out what a synthesizer sends over MIDI
when you push a key or turn a knob.  In particular MM is useful for finding
out what data is available to a CMT program by calling
@i(getbuf@Index(getbuf)), because that is how MM gets all of its data.

MM is @i(not) a complete MIDI monitor that prints @i(every) MIDI byte
sent to it.  In particular, MIDI exclusive messages are not displayed.
MM will only print continuous control information if you type ``y'' (yes)
to the prompt:
@begin(example)
pitch bend etc. on? [n]
@end(example)

@section(Command Line Options)
The following command line options are available:
@begin(itemize)
-debug (or -d): turn on debugging code.

-help: print a list of command line options.

-miditrace (or -m): turn on MIDI byte trace.

-trace (or -t): turn on music operation trace.

-block: turns off the MPU-401 MIDI THRU function so that the input
is not passed to the output.
@end(itemize)

@subsection(Examples)
Run the MM program:
@begin(example)
mm
@end(example)

Run MM with MIDI THRU on MPU-401 disabled:
@begin(example)
mm -block
@end(example)
