@part(transcribe, root="cmtman.mss")
@chapter(The Transcribe Program)
@section(Overview)
@index(Transcribe)
The @i(Transcribe) program is used to record@Index(record) performances via
MIDI and to translate them into Adagio.  Rather than attempt to guess
musical durations (like a dotted-quarter), Transcribe records all times and
durations in hundredths of seconds.  This program, together with
Record makes it fairly simple to build up complex Adagio scores one
part at a time.  Transcribed music can be copied, edited, or repeated using
an ordinary text editor.  The output from Transcribe might also be useful
in the study or evaluation of performances.

@section(Tutorial)
To use Transcribe,
 type
@begin(example)
transcri @i(filename)
@end(example)
where @i(filename) is the name of the file you want to create.  If you
just type @i(transcri), you will be prompted for a file name.  In either
case, a default extension of ``.gio'' will be assumed.
Transcribe will then ask you if you want to record control information:
@begin(programexample)
Pitch bend, etc. on? [n]
@end(programexample)
Type ``y'', ``n'', or just @c[return] for the default (n).  Generally, you
should type @c(return).  At present, recording control information tends to
use up the available recording memory very quickly, so it is of limited use.
When you have finished what you want to
play, type the space bar on the IBM.  This signals the program to stop and
write out the notes.  This file can now be played by Adagio and what comes
out will be very similar to what you just heard yourself play.

@section(Timbre)
@Index(Timbre)@Index(MIDI Program)@Index(Program Change Command)@Index(Z)
When you start Transcribe, it sends MIDI program change commands to program 1
on all MIDI channels.  When you make a program change on the
synthesizer, Transcribe records the change and translates it into an
Adagio Z attribute.  This corresponds to the default Z1 attribute in 
Adagio and to the fact that Adagio also initializes all MIDI channels
to program 1.

@b(Note:) Transcribe (and Record) record Z attributes whenever they receive
a MIDI Program Change command.  Synthesizers normally send this when you
change a preset sound using the controls on the synthesizer.  One noteable
exception is that if a Yamaha synthesizer is in the ``Sys Info Avail'' 
@Index(Sys Info Avail) mode,
then pressing a button to change the program causes the synthesizer to dump
all of the internal data comprising the program.  No MIDI Program Change
command is sent, so Transcribe records nothing.  You can find out what is
happening by running the MM (Midi Monitor) @Index(Midi Monitor)@Index(MM)
program and pushing a program change button on your synthesizer.  For
Yamaha synthesizers, the mode should be ``Sys Info Unavail'', which is a
fairly cryptic way to say ``send program numbers instead of program data''.

@section(Command Line Options)
The following options can be specified in the command line:
@begin(itemize)
-debug (or -d): turn on debugging code.

-help: print a list of command line options.

-miditrace (or -m): turn on MIDI byte trace.

-trace (or -t): turn on music operation trace.

-block: turns off the MPU-401 MIDI THRU function so that the input
is not passed to the output.

-control (or -c) on: record control information, do not present the
``Pitch bend, etc. on?'' query.

-control (or -c) off: do not record control information, do not present the
``Pitch bend, etc. on?'' query.
@end(itemize)

@subsection(Examples)
Print information about command line options:
@begin(example)
transcri -help
@end(example)

Record data into file @i(foo.gio), do not record control information,
and turn off the MIDI THRU function of the MPU-401:
@begin(example)
transcri foo -c off -block
@end(example)

